package at.bestsolution.drawswf;

/* DescriptionHandler
 *
 * Represents the objects that have been described.
 *
 * @author Mike Lam
 */

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import java.io.*;

public class DescriptionHandler
{
    public String objectName;
    public String objectDescription;
    public String objectStatus;

    public DescriptionHandler(String name, String description, String status) {
        objectName = name;
        objectDescription = description;
        objectStatus = status;
    }

    public DescriptionHandler(String xmlString) {
        Element theXMLObj = stringToElement(xmlString);
        Attribute nameAtt = theXMLObj.getAttribute("name");
        if (nameAtt != null) objectName = nameAtt.getValue();
        Attribute statusAtt = theXMLObj.getAttribute("status");
        if (statusAtt != null) objectStatus = statusAtt.getValue();
        Attribute descriptionAtt = theXMLObj.getAttribute("description");
        if (descriptionAtt != null) objectDescription = descriptionAtt.getValue();
    }

    public String getObjectName() {
        return objectName;
    }

    public String getObjectDescription() {
        return objectDescription;
    }

    public String getObjectStatus() {
        return objectStatus;
    }

    public void setObjectName(String name)
    {
        objectName = name;
    }

    public void setObjectDescription(String description) {
        objectDescription = description;
    }

    public void setObjectStatus(String status) {
        objectStatus = status;
    }

    public String getXMLString() {
        Element e = new Element("desc");
        e.setAttribute("status", objectStatus);
        e.setAttribute("name", objectName);
        e.setAttribute("description", objectDescription);
        return elementToString(e);
    }

    public String elementToString(Element e) {
        String theString = null;
        try {
            XMLOutputter xmlOut = new XMLOutputter();
            theString = xmlOut.outputString(e);
        } catch (Exception ex) {
        //ex.printStackTrace();
        }
        return theString;
    }

    public Element stringToElement(String s) {
        Element e = null;
        try {
            StringReader sR = new StringReader(s);
            SAXBuilder sB = new SAXBuilder();
            Document doc = sB.build(sR);
            e = doc.detachRootElement();
        } catch (Exception ex) {
        //ex.printStackTrace();
        }
        return e;
    }
}
