/*
 *  Copyright (c) 2002
 *  bestsolution EDV Systemhaus GmbH,
 *  http://www.bestsolution.at
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Header: /usr/bestsolution/cvsroot/java/draw_swf/at/bestsolution/drawswf/drawobjects/StraightLine.java,v 1.25 2003/01/24 01:35:53 tom Exp $
 */

/*
 * Line.java
 *
 * Created on 21. Mai 2002, 22:57
 */

package at.bestsolution.drawswf.drawobjects;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.awt.geom.Line2D;
import java.awt.BasicStroke;
import java.awt.geom.AffineTransform;

import java.awt.event.KeyEvent;

import javax.swing.JTable;
import javax.swing.table.TableModel;

import com.anotherbigidea.flash.movie.Movie;
import com.anotherbigidea.flash.movie.Frame;
import com.anotherbigidea.flash.movie.Shape;
import com.anotherbigidea.flash.movie.Instance;
import com.anotherbigidea.flash.structs.AlphaColor;

import org.w3c.dom.Element;

import at.bestsolution.drawswf.*;

/**
 *
 * @author  tom
 */
public class StraightLine extends DrawObject
{
    private Line2D line;
    private static int instance_counter = 1;
    private TableModel model_;
    private JTable options_table_;

    private MainWindow mWin;
    private int objectID;

    //----------------------------------------------------------------------------
    /** Creates a new instance of Line */
    public StraightLine(MainWindow mW)
    {
        super( "StraightLine ", mW);
        instance_counter++;
        setObjectId();
        mWin = mW;
        line = null;
    }

    public String getName() {
        return "StraightLine " + getObjectId();
    }

    public static void resetObjectCounter()
    {
        instance_counter = 1;
    }

    public int getObjectId() {
        return objectID;
    }

    public void setObjectId() {
        objectID = instance_counter - 1;
    }

    public void setObjectId(int ID) {
        objectID = ID;
    }

    //----------------------------------------------------------------------------
    public void drawObject(Movie movie, int layer, int speed)
    {
        Frame frame = movie.appendFrame();

        AlphaColor linecolor = new AlphaColor( pen_color_.getRed(), pen_color_.getGreen(), pen_color_.getBlue(), pen_color_.getAlpha() );

        Shape shape = new Shape();
        shape.defineLineStyle((stroke_.getLineWidth()), linecolor);
        shape.setLineStyle(1);
        shape.move( line.getX1(), line.getY1());
        shape.line( line.getX2(), line.getY2());

        Instance instance = frame.placeSymbol(shape, 0, 0);

        // sleep in flash...
        for (int count = 0; count < 5; count++ )
        {
            movie.appendFrame();
        }
    }

    //----------------------------------------------------------------------------
    public void drawObject(Graphics2D g, DrawingPanel panel)
    {
        g.setStroke(stroke_);
        g.setColor(pen_color_);
        g.draw( line );
        if (panel.isReplay() == true)
        {
            pause(100*ANIMATION_DELAY);
        }
    }

    //----------------------------------------------------------------------------
    public void mouseDragged(int x, int y, Graphics2D g)
    {
        g.setXORMode(Color.white);

        g.setColor(pen_color_);
        g.setStroke(stroke_);
        g.draw( line );
        line = new Line2D.Double(line.getX1(), line.getY1(), x, y);
        g.draw( line );
    }

    //----------------------------------------------------------------------------
    public void mousePressed(int x, int y, Graphics2D g)
    {
        g.setColor(pen_color_);
        g.setStroke(stroke_);
        line = new Line2D.Double(x, y, x, y);
        g.draw( line );
    }

    //----------------------------------------------------------------------------
    public boolean mouseReleased(int x, int y, Graphics2D g)
    {
        g.setXORMode(Color.white);

        g.setColor(pen_color_);
        g.setStroke(stroke_);
        g.draw( line );
        line = new Line2D.Double(line.getX1(), line.getY1(), x, y);
        g.setPaintMode();
        g.setColor(fill_color_);
        g.fill( line );
        g.setColor(pen_color_);
        g.draw( line );

        return ( line.getP1().distance(line.getP2()) > 0.0 );
    }

    public void keyPressed(Graphics2D g, KeyEvent e)
    {
        g.setColor(pen_color_);
        g.setStroke(stroke_);

        /* The following are for resizing a drawing object */
        if((e.getModifiers() == KeyEvent.CTRL_MASK) &&
            (e.getKeyCode() == KeyEvent.VK_UP))
        {
            double slope = (line.getY2()-line.getY1())/(line.getX2()-line.getX1());

            if(line.getX2() > line.getX1())
            {
                double newY2 = line.getY2()+slope*10;
                double newX2 = line.getX2()+10;
                line.setLine(line.getX1(), line.getY1(), newX2, newY2);
                g.draw(line);
            }

            if(line.getX1() > line.getX2())
            {
                double newY2 = line.getY2()-slope*10;
                double newX2 = line.getX2()-10;
                line.setLine(line.getX1(), line.getY1(), newX2, newY2);
                g.draw(line);
            }
        }

        if((e.getModifiers() == KeyEvent.CTRL_MASK) &&
            (e.getKeyCode() == KeyEvent.VK_DOWN))
        {
            double slope = (line.getY2()-line.getY1())/(line.getX2()-line.getX1());

            if(line.getX1() > line.getX2())
            {
                double newY2 = line.getY2()+slope*10;
                double newX2 = line.getX2()+10;
                line.setLine(line.getX1(), line.getY1(), newX2, newY2);
                g.draw(line);
            }

            if(line.getX2() > line.getX1())
            {
                double newY2 = line.getY2()-slope*10;
                double newX2 = line.getX2()-10;
                line.setLine(line.getX1(), line.getY1(), newX2, newY2);
                g.draw(line);
            }
        }


        /* The following are for translating a drawing object */
        if((e.getModifiers() == KeyEvent.SHIFT_MASK) &&
            (e.getKeyCode() == KeyEvent.VK_DOWN))
        {
            line.setLine(line.getX1(), line.getY1()+10, line.getX2(), line.getY2()+10);
            g.draw(line);
        }

        if((e.getModifiers() == KeyEvent.SHIFT_MASK) &&
            (e.getKeyCode() == KeyEvent.VK_UP))
        {
            line.setLine(line.getX1(), line.getY1()-10, line.getX2(), line.getY2()-10);
            g.draw(line);
        }

        if((e.getModifiers() == KeyEvent.SHIFT_MASK) &&
            (e.getKeyCode() == KeyEvent.VK_LEFT))
        {
            line.setLine(line.getX1()-10, line.getY1(), line.getX2()-10, line.getY2());
            g.draw(line);
        }

        if((e.getModifiers() == KeyEvent.SHIFT_MASK) &&
            (e.getKeyCode() == KeyEvent.VK_RIGHT))
        {
            line.setLine(line.getX1()+10, line.getY1(), line.getX2()+10, line.getY2());
            g.draw(line);
        }


        /* The following are for rotating a drawing object */
       if((e.getModifiers() == KeyEvent.ALT_MASK) &&
           (e.getKeyCode() == KeyEvent.VK_UP))
        {
            double anchorX = (line.getX1() + line.getX2())/2;
            double anchorY = (line.getY1() + line.getY2())/2;

            //System.out.println(line.getX1() +"****************");
//            AffineTransform aft = (AffineTransform)g.getTransform();
//            g.rotate(Math.toRadians(45), anchorX, anchorY);

//System.out.println(line.getX1() +"****************");

            line.setLine(line.getX1(), line.getY2(), line.getX2(), line.getY1());
            g.draw(line);
        }
    }

    //----------------------------------------------------------------------------
    public String toSVG(long time)
    {
        return "<" + DrawObjectFactory.SVG_STRAIGHT_LINE
        + " id=\"" + getObjectId()
        + "\" sender=\"" + getSender()
        + "\" x1=\"" + line.getX1()
        + "\" y1=\"" + line.getY1()
        + "\" x2=\"" + line.getX2()
        + "\" y2=\"" + line.getY2() + "\" "
        + toSVGStroke() + "/>";
    }

    //----------------------------------------------------------------------------
    protected void createAWTObject(Element xml_node, double scale)
    {
        double x1 = Double.parseDouble( xml_node.getAttribute("x1") );
        double y1 = Double.parseDouble( xml_node.getAttribute("y1") );
        double x2 = Double.parseDouble( xml_node.getAttribute("x2") );
        double y2 = Double.parseDouble( xml_node.getAttribute("y2") );

        setAWTStroke(xml_node, scale);

        line = new Line2D.Double( x1 * scale, y1 * scale, x2 * scale, y2 * scale );
    }

    //----------------------------------------------------------------------------
    public void setPropertyX1( String x )
    {
        line.setLine( Double.parseDouble( x ), line.getY1(), line.getX2(), line.getY2() );
        repaint();
    }

    //----------------------------------------------------------------------------
    public double getPropertyX1()
    {
        return line.getX1();
    }

    //----------------------------------------------------------------------------
    public void setPropertyY1( String y )
    {
        line.setLine( line.getX1(), Double.parseDouble( y ), line.getX2(), line.getY2() );
        repaint();
    }

    //----------------------------------------------------------------------------
    public double getPropertyY1()
    {
        return line.getY1();
    }

    //----------------------------------------------------------------------------
    public void setPropertyX2( String x )
    {
        line.setLine( line.getX1(), line.getY1(), Double.parseDouble( x ), line.getY2() );
        repaint();
    }

    //----------------------------------------------------------------------------
    public double getPropertyX2()
    {
        return line.getX2();
    }

    //----------------------------------------------------------------------------
    public void setPropertyY2( String y )
    {
        line.setLine( line.getX1(), line.getY2(), line.getX2(), Double.parseDouble( y ) );
        repaint();
    }

    //----------------------------------------------------------------------------
    public double getPropertyY2()
    {
        return line.getY2();
    }

    public double getPropertyX() {
        return line.getX1();
    }

    public double getPropertyY() {
        return line.getY1();
    }

    //----------------------------------------------------------------------------
    public void setPropertyPenColor( Color pen_color )
    {
        pen_color_ = pen_color;
        repaint();
    }

    //----------------------------------------------------------------------------
    public Color getPropertyPenColor()
    {
        return pen_color_;
    }

    //----------------------------------------------------------------------------
    public void setPropertyStrokeWidth( String width )
    {
        stroke_ = new BasicStroke( Float.parseFloat( width ) );
        repaint();
    }

    //----------------------------------------------------------------------------
    public float getPropertyStrokeWidth()
    {
        return stroke_.getLineWidth();
    }

    //----------------------------------------------------------------------------
    public boolean contains(Point2D p)
    {
        return line.intersects( p.getX() - 1.0, p.getY() - 1.0, 3.0, 3.0);
    }

    //----------------------------------------------------------------------------
    public void move(double x, double y)
    {
        line.setLine( line.getX1() + x, line.getY1() + y, line.getX2() + x, line.getY2() + y );
    }
}
