/*
 * Created on 22.02.2003
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code Template
 */
package at.bestsolution.drawswf.toolbar;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.net.URL;
import java.util.ResourceBundle;

import at.bestsolution.drawswf.MainWindow;
import at.bestsolution.drawswf.actions.AbstractDrawAction;
import at.bestsolution.drawswf.actions.FileAction;
import at.bestsolution.drawswf.actions.GraphicTemplateAction;
import at.bestsolution.drawswf.actions.SaveSWFAction;
import at.bestsolution.drawswf.DrawObjectList;

/**
 * @author tom
 */
public class DrawFileToolbar extends JToolBar implements DrawToolbarInterface
{

    protected static final String tool_bar_icon_path_ = "at/bestsolution/drawswf/images/16x16/";
    private DrawObjectList draw_object_list_;
    private MainWindow mWin;

    public DrawFileToolbar(DrawObjectList dol, MainWindow mW)
    {
        super();
        mWin = mW;
        setFloatable(false);
        draw_object_list_ = dol;
        initToolbar();
    }


    private void addFileAction(String displayedText, String description, String icon_name, boolean load, int mnemonicKey, KeyStroke accelerator, boolean append)
    {
        FileAction load_action = new FileAction(description, icon_name, mWin.getDrawingPanel(), load, append);

        ImageIcon icon;
        URL icon_url;
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ icon_name);
        icon = new ImageIcon(icon_url);
        JButton button = new JButton(icon);
        button.setAction(load_action);
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));
        add(button);
    }

    private void addDeleteAction()
    {
        ImageIcon icon;
        URL icon_url;
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ "delete.png");
        icon = new ImageIcon(icon_url);
        JButton button = new JButton(icon);
        button.setToolTipText("Delete Object");
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));
        add(button);
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            draw_object_list_.deleteObjectAndSend();
        }
        });
    }

    private void addClearAction()
    {
        ImageIcon icon;
        URL icon_url;
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ "clear.png");
        icon = new ImageIcon(icon_url);
        JButton button = new JButton(icon);
        button.setToolTipText("Clear Whiteboard");
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));
        add(button);
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            draw_object_list_.clearWhiteboard();
        }
        });
    }

    private void addGraphicTemplateAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        //GraphicTemplateAction template_action = new GraphicTemplateAction(description, icon_name, mWin.getDrawingPanel());
        //add(template_action);
    }


    private void addSaveSWFAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
 /*
        SaveSWFAction save_swf_action = new SaveSWFAction(description, icon_name, mWin.getDrawingPanel());

        ImageIcon icon;
        URL icon_url;
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ icon_name);
        icon = new ImageIcon(icon_url);
        JButton button = new JButton(icon);
        button.setAction(save_swf_action);
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));
        add(button);
*/
    }

    private void addSaveRemoteSWFAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
    }


    private void initToolbar()
    {
        ResourceBundle international = MainWindow.getI18n();

        addFileAction( international.getString( "MainWindowFileItemOpen" ), international.getString( "MainWindowFileItemOpenTooltip"), "open.png", true, international.getString( "MainWindowFileItemOpenMn" ).charAt(0), KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK), false );
        addFileAction( international.getString( "MainWindowFileItemSaveAs" ), international.getString( "MainWindowFileItemSaveAsTooltip" ), "saveas.png", false, international.getString( "MainWindowFileItemSaveAsMn" ).charAt(0), null, false );
        addClearAction();
        addDeleteAction();
    }

    public void addGenericToolbarItem(AbstractDrawAction draw_action, int position)
    {
    }

}
