/*
 * Created on 22.02.2003
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code Template
 */
package at.bestsolution.drawswf.toolbar;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.net.URL;
import java.util.ResourceBundle;

import at.bestsolution.drawswf.MainWindow;
import at.bestsolution.drawswf.actions.AbstractDrawAction;
import at.bestsolution.drawswf.actions.FileAction;
import at.bestsolution.drawswf.actions.GraphicTemplateAction;
import at.bestsolution.drawswf.actions.SaveSWFAction;
import at.bestsolution.drawswf.DrawObjectList;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;

import at.bestsolution.drawswf.DrawObjectList;
import at.bestsolution.drawswf.MainWindow;
import at.bestsolution.drawswf.actions.AbstractDrawAction;
import at.bestsolution.drawswf.actions.SetCanvasSizeAction;
import at.bestsolution.drawswf.actions.SetColorAction;
import at.bestsolution.drawswf.actions.SetDrawingModeAction;
import at.bestsolution.drawswf.actions.SetLineWidthAction;
import at.bestsolution.drawswf.drawobjects.DrawObjectFactory;
import at.bestsolution.drawswf.icon.FillColorIcon;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

/**
 * @author tom
 *
 * Revisions by:  Mike Lam
 */
public class DrawToolsToolbar extends JToolBar
{
    private JRadioButton[] toolbarRadioButtons_;
    private DrawObjectList draw_object_list_;
    protected static final String tool_bar_icon_path_ = "at/bestsolution/drawswf/images/16x16/";

    private MainWindow mWin;

    public DrawToolsToolbar(MainWindow mW, DrawObjectList dol)
    {
        super();
        mWin = mW;
        setFloatable(false);
        draw_object_list_ = dol;
        toolbarRadioButtons_ = new JRadioButton[DrawObjectFactory.MAX_OBJECTS + 1];
        initToolbar();
    }

    private void addSetColorAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator, boolean pen_color,  Color color, int border_v)
    {
        JButton button = new JButton();
        button.setAction( new SetColorAction(mWin.getDrawingPanel(), pen_color, button));
        button.setToolTipText(description);
        button.setMargin(new Insets(1,1,1,1));

        ImageIcon icon;
        URL icon_url;

        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ icon_name);
        icon = new ImageIcon(icon_url);
        button.setIcon( new FillColorIcon(color,16,16,2,border_v) );

        add(button);
    }

    private void addDrawObject(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator, int mode)
    {
        ImageIcon icon;
        URL icon_url;

        SetDrawingModeAction draw_action = new SetDrawingModeAction(description, mWin.getDrawingPanel(), mode, MainWindow.MAIN_WINDOW, mode);
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ icon_name);
        icon = new ImageIcon(icon_url);

        JButton button = new JButton(icon);
        button.setAction(draw_action);
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));

        add(button);
   }

    private void addSetLineWidthAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        SetLineWidthAction line_width_action = new SetLineWidthAction(description, icon_name, mWin.getDrawingPanel());

        ImageIcon icon;
        URL icon_url;
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ icon_name);
        icon = new ImageIcon(icon_url);
        JButton button = new JButton(icon);
        button.setAction(line_width_action);
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));
        add(button);
    }

    private void addSetCanvasSizeAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        SetCanvasSizeAction canvas_action = new SetCanvasSizeAction(description, icon_name, mWin.getDrawingPanel(), MainWindow.theFrame);
        add(canvas_action);
    }

    private void addFileAction(String displayedText, String description, String icon_name, boolean load, int mnemonicKey, KeyStroke accelerator, boolean append)
    {
        FileAction load_action = new FileAction(description, icon_name, mWin.getDrawingPanel(), load, append);

        ImageIcon icon;
        URL icon_url;
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ icon_name);
        icon = new ImageIcon(icon_url);
        JButton button = new JButton(icon);
        button.setAction(load_action);
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));
        add(button);
    }

    private void addDeleteAction()
    {
        ImageIcon icon;
        URL icon_url;
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ "delete.png");
        icon = new ImageIcon(icon_url);
        JButton button = new JButton(icon);
        button.setToolTipText("Delete");
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));
        add(button);
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            draw_object_list_.deleteObjectAndSend();
        }
        });
    }

    private void addClearAction()
    {
        ImageIcon icon;
        URL icon_url;
        icon_url = getClass().getClassLoader().getResource(tool_bar_icon_path_+ "clear.png");
        icon = new ImageIcon(icon_url);
        JButton button = new JButton(icon);
        button.setToolTipText("Clear Whiteboard");
        button.setIcon(icon);
        button.setMargin(new Insets(1,1,1,1));
        add(button);
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            draw_object_list_.clearWhiteboard();
        }
        });
    }

    private void initToolbar()
    {
        ResourceBundle international = MainWindow.getI18n();

        setMargin(new Insets(1,15,1,15));

        addFileAction( international.getString( "MainWindowFileItemOpen" ), "Open", "open.png", true, international.getString( "MainWindowFileItemOpenMn" ).charAt(0), KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK), false );
        addFileAction( international.getString( "MainWindowFileItemSaveAs" ), "Save As", "saveas.png", false, international.getString( "MainWindowFileItemSaveAsMn" ).charAt(0), null, false );
        addClearAction();
        addDeleteAction();

        addDrawObject(
            international.getString("MainWindowToolsSubDrawingObjItemEdit"),
            "Select and Move",
            "arrow.png",
            international.getString("MainWindowToolsSubDrawingObjItemEditMn").charAt(0),
            null,
            DrawObjectFactory.MAX_OBJECTS);

        addDrawObject(
            international.getString("MainWindowToolsSubDrawingObjItemLine"),
            "Pencil",
            "free_line.png",
            international.getString("MainWindowToolsSubDrawingObjItemLineMn").charAt(0),
            null,
            DrawObjectFactory.LINE);

        addDrawObject(
            international.getString("MainWindowToolsSubDrawingObjItemSLine"),
            "Line",
            "straight_line.png",
            international.getString("MainWindowToolsSubDrawingObjItemSLineMn").charAt(0),
            null,
            DrawObjectFactory.STRAIGHT_LINE);

        addDrawObject(
            international.getString("MainWindowToolsSubDrawingObjItemRect"),
            "Rectangle",
            "rectangle.png",
            international.getString("MainWindowToolsSubDrawingObjItemRectMn").charAt(0),
            null,
            DrawObjectFactory.RECTANGLE);

        addDrawObject(
            international.getString("MainWindowToolsSubDrawingObjItemEll"),
            "Ellipse",
            "ellipse.png",
            international.getString("MainWindowToolsSubDrawingObjItemEllMn").charAt(0),
            null,
            DrawObjectFactory.ELLIPSE);

        addDrawObject(
            international.getString("MainWindowToolsSubDrawingObjItemText"),
            "Text",
            "font.png",
            international.getString("MainWindowToolsSubDrawingObjItemTextMn").charAt(0),
            null,
            DrawObjectFactory.TEXT);

        /*addDrawObject(
            international.getString("MainWindowToolsSubDrawingObjItemPict"),
            international.getString("MainWindowToolsSubDrawingObjItemPictTooltip"),
            "picture.png",
            international.getString("MainWindowToolsSubDrawingObjItemPictMn").charAt(0),
            null,
            DrawObjectFactory.PICTURE);*/

        addSetColorAction(
            international.getString("MainWindowToolsSubColorsItemPencolor"),
            "Pen Colour",
            "pen_color.png",
            international.getString("MainWindowToolsSubColorsItemPencolorMn").charAt(0),
            null,
            true, Color.BLACK, 7);
        addSetColorAction(
            international.getString("MainWindowToolsSubColorsItemFillcolor"),
            "Fill Colour",
            "fill_color.png",
            international.getString("MainWindowToolsSubColorsItemFillcolorMn").charAt(0),
            null,
            false, Color.BLUE, 2);

        addSetLineWidthAction(
            international.getString("MainWindowToolsItemLinewidth"),
            "Width",
            "line_width.png",
            international.getString("MainWindowToolsItemLinewidthMn").charAt(0),
            null);
    }

    public void changeDrawingType(int index)
    {
    }

    public void addGenericToolbarItem(AbstractDrawAction draw_action, int position)
    {
    }
}
