package ca.utoronto.atrc.whiteboard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import com.incors.plaf.kunststoff.*;

public class ACommLogin {

    // as always, the main class
    public ACommunicator aComm;
    
    // GUI elements
    JFrame loginFrame;
    JPanel thePanel;
    JPanel registerPanel;
    JButton login;
    JButton cancel;
    JLabel uLabel;
    JTextField uField;
    JLabel pLabel;
    JPasswordField pField;   
    JLabel sLabel;
    JTextField sField;
    JLabel portLabel;
    JTextField portField;   
    
    JButton registerButton;

    public ACommLogin(ACommunicator aC) {
    
        aComm = aC;
	
	KunststoffLookAndFeel kunststoffLnF = new KunststoffLookAndFeel();
        KunststoffLookAndFeel.setCurrentTheme( new KunststoffTheme() );
        try {
	    UIManager.setLookAndFeel(kunststoffLnF);
	} catch (Exception e) { e.printStackTrace(); }
	    
        loginFrame = new JFrame("AComm: Login Screen");
	loginFrame.addWindowListener(new WindowAdapter() {
           public void windowClosing(WindowEvent e) {
	       aComm.killItAll();
           }});
	login = new JButton("Login");
	login.setMnemonic(KeyEvent.VK_L);
	login.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        doLogin();
	    }});

	cancel = new JButton("Cancel");
	cancel.setMnemonic(KeyEvent.VK_C);
	cancel.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        aComm.killItAll();
	    }});	    
	    
	    	
	uLabel = new JLabel("User Name:");
	uLabel.setHorizontalTextPosition(JLabel.RIGHT);
	uField = new JTextField(15);
	uLabel.setLabelFor(uField);
	uLabel.setDisplayedMnemonic(KeyEvent.VK_U);
		
	pLabel = new JLabel("Password:");
	pLabel.setHorizontalTextPosition(JLabel.RIGHT);
	pField = new JPasswordField(15);
	pLabel.setLabelFor(pField);
	pLabel.setDisplayedMnemonic(KeyEvent.VK_P);
				
	sLabel = new JLabel("Server:");
	sLabel.setHorizontalTextPosition(JLabel.RIGHT);
	sField = new JTextField(15);
	sLabel.setLabelFor(sField);
	sLabel.setDisplayedMnemonic(KeyEvent.VK_S);
	
	portLabel = new JLabel("Port:");
	portLabel.setHorizontalTextPosition(JLabel.RIGHT);
	portField = new JTextField(5);  
	portLabel.setLabelFor(portField);
	portLabel.setDisplayedMnemonic(KeyEvent.VK_T);
	
	registerButton = new JButton("Register a New Account");
	registerButton.setMnemonic(KeyEvent.VK_R);
	registerButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        doRegister();
	    }});
	    		
	if (aComm.options.p != null) {
	    uField.setText(aComm.options.p.getProperty("userName"));
	    sField.setText(aComm.options.p.getProperty("server"));
	    portField.setText(aComm.options.p.getProperty("port"));
	}
	
	thePanel = new JPanel();
	thePanel.setLayout(new GridLayout(5,2));
	registerPanel = new JPanel();
	
	thePanel.add(uLabel);
	thePanel.add(uField);
	thePanel.add(pLabel);
	thePanel.add(pField);
	thePanel.add(sLabel);
	thePanel.add(sField);
	thePanel.add(portLabel);
	thePanel.add(portField);
	thePanel.add(login);
	thePanel.add(cancel);
	thePanel.setBorder(BorderFactory.createTitledBorder("Login to your Jabber Account: "));
	
	registerPanel.add(registerButton);
	registerPanel.setBorder(BorderFactory.createTitledBorder("or, Register a New Jabber Account: "));
	
	loginFrame.getContentPane().setLayout(new BorderLayout());
	loginFrame.getContentPane().add(thePanel, "North");
	loginFrame.getContentPane().add(registerPanel, "South");
	loginFrame.pack();
	
	loginFrame.setVisible(true);
    }
    
    public void doRegister() {
        loginFrame.setVisible(false);
	loginFrame.dispose();
        ACommRegister theRegister = new ACommRegister(aComm);
    }
    
    public void doLogin() {
    
    
	String pass = new String(pField.getPassword());
	
        if (uField.getText() ==  null || uField.getText().length() == 0) {
	    JOptionPane.showMessageDialog(thePanel, "Error: you must enter a user name");
	    return;
	}
        if (pass ==  null || pass.length() == 0) {
	    JOptionPane.showMessageDialog(thePanel, "Error: you must enter a password");
	    return;
	}
        if (sField.getText() ==  null || sField.getText().length() == 0) {
	    JOptionPane.showMessageDialog(thePanel, "Error: you must enter a server");
	    return;
	}
        if (portField.getText() ==  null || portField.getText().length() == 0) {
	    portField.setText("5222");
	}  	
	
	aComm.options.p.setProperty("userName",uField.getText());
	aComm.options.p.setProperty("server", sField.getText());
	aComm.options.p.setProperty("port", portField.getText());
	aComm.options.save();
	
        loginFrame.setVisible(false);
	loginFrame.dispose();
	aComm.doLogin(pass);
    }
}

