package ca.utoronto.atrc.whiteboard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ACommOptionGUI {

    // as always, the main class
    public ACommunicator aComm;
    
    // GUI elements
    JFrame theFrame;
    JPanel soundPanel = new JPanel();
    JPanel soundPanel1 = new JPanel();
    JPanel soundPanel2 = new JPanel();
    JPanel soundPanel3 = new JPanel();
    JPanel bottomPanel = new JPanel();
    
    JCheckBox nCBox;
    JButton nCButton;
    JCheckBox nMBox;
    JButton nMButton;
    JCheckBox onBox;
    JCheckBox offBox;
    JButton onButton;
    JButton offButton;
   
    
    JButton saveButton;
    JButton cancelButton;

    public ACommOptionGUI(ACommunicator aC) {
    
        aComm = aC;
	    
        theFrame = new JFrame("A-Communicator: Options Screen");
	theFrame.addWindowListener(new WindowAdapter() {
           public void windowClosing(WindowEvent e) {
	       theFrame.setVisible(false);
	       theFrame.dispose();
           }});
	   
	
	      
	// sound panel
	soundPanel.setLayout(new BorderLayout());
	soundPanel1.setLayout(new GridLayout(4,1));
	soundPanel2.setLayout(new GridLayout(4,1));
	soundPanel3.setLayout(new GridLayout(4,1));
		
	nCBox = new JCheckBox();
	JLabel nCLabel = new JLabel("Play sound for new chat messages?");
	nCButton = new JButton("New Chat Sound");
	nCButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        aComm.toolKit.playNewChatSound();
	    }});
	nCLabel.setLabelFor(nCBox);
	nCLabel.setDisplayedMnemonic(KeyEvent.VK_N);
	nCButton.setMnemonic(KeyEvent.VK_C);
	soundPanel1.add(nCLabel);
	soundPanel2.add(nCBox);
	soundPanel3.add(nCButton);
	
	
	
	nMBox = new JCheckBox();
	JLabel nMLabel = new JLabel("Play sound for new messages?");
	nMButton = new JButton("New Message Sound");
	nMButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        aComm.toolKit.playNewMessageSound();
	    }});
	nMLabel.setLabelFor(nMBox);
	nMLabel.setDisplayedMnemonic(KeyEvent.VK_P);
	nMButton.setMnemonic(KeyEvent.VK_M);	
	soundPanel1.add(nMLabel);
	soundPanel2.add(nMBox);
	soundPanel3.add(nMButton);
	onBox = new JCheckBox();
	JLabel onLabel = new JLabel("Play sound when contacts come online?");
	onButton = new JButton("Online Sound");
	onButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        aComm.toolKit.playOnlineSound();
	    }});	    
	onLabel.setLabelFor(onBox);
	onLabel.setDisplayedMnemonic(KeyEvent.VK_S);
	onButton.setMnemonic(KeyEvent.VK_O);
	soundPanel1.add(onLabel);
	soundPanel2.add(onBox);
	soundPanel3.add(onButton);
	
	offBox = new JCheckBox();
	JLabel offLabel = new JLabel("Play sound when contacts go offline?");
	offButton = new JButton("Offline Sound");
	offButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        aComm.toolKit.playOfflineSound();
	    }});	
	offLabel.setLabelFor(offBox);
	offLabel.setDisplayedMnemonic(KeyEvent.VK_W);
	offButton.setMnemonic(KeyEvent.VK_F);
	soundPanel1.add(offLabel);
	soundPanel2.add(offBox);
	soundPanel3.add(offButton);
	
	soundPanel.setBorder(BorderFactory.createTitledBorder("Sound Options")); 
	soundPanel.add(soundPanel1, "West");
	soundPanel.add(soundPanel2, "Center");
	soundPanel.add(soundPanel3, "East");
		   
	// bottom panel
	bottomPanel.setLayout(new BoxLayout(bottomPanel, BoxLayout.X_AXIS));  
	saveButton = new JButton("Save");
	saveButton.setMnemonic(KeyEvent.VK_S);
	saveButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        saveIt();
	        theFrame.setVisible(false);
	        theFrame.dispose();	        
	    }});
	cancelButton = new JButton("Cancel");
	cancelButton.setMnemonic(KeyEvent.VK_C);
	cancelButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        theFrame.setVisible(false);
	        theFrame.dispose();	        
	    }});	    
	bottomPanel.add(Box.createHorizontalGlue());
	bottomPanel.add(saveButton);
	bottomPanel.add(cancelButton);
	bottomPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5)); 
	
	initialize();
		    
	theFrame.getContentPane().setLayout(new BorderLayout());
	theFrame.getContentPane().add(soundPanel, "Center");
	theFrame.getContentPane().add(bottomPanel, "South");    	
	theFrame.pack();
	theFrame.setVisible(true);
    }
    
    public void initialize() {
        if (aComm.jidOptions.getBoolean("playChatSound")) nCBox.setSelected(true);
	else nCBox.setSelected(false);
        if (aComm.jidOptions.getBoolean("playMessageSound")) nMBox.setSelected(true);
	else nMBox.setSelected(false);
        if (aComm.jidOptions.getBoolean("playOnlineSound")) onBox.setSelected(true);
	else onBox.setSelected(false);
        if (aComm.jidOptions.getBoolean("playOfflineSound")) offBox.setSelected(true);
	else offBox.setSelected(false);
	
	
    }
    
    public void saveIt() {
	aComm.jidOptions.put("playChatSound", ""+nCBox.isSelected());
	aComm.jidOptions.put("playMessageSound", ""+nMBox.isSelected());	
	aComm.jidOptions.put("playOnlineSound", ""+onBox.isSelected());	
	aComm.jidOptions.put("playOfflineSound", ""+offBox.isSelected());
	
	aComm.jidOptions.save();	
    }
}

