package ca.utoronto.atrc.whiteboard;

// Copyright 2003, Adaptive Technology Resource Centre
// Written by: Taras Kowaliw, taras.kowaliw@utoronto.ca

import java.util.Properties;
import java.io.*;

public class ACommOptions {    
    
    public Properties p;
    public String fileName;

    public ACommOptions(String jid) {
        fileName = System.getProperty("user.home")+ File.separator + ".drawswf" + File.separator + jid + ".properties";
        //fileName = "options/"+jid+".properties";
	p = new Properties();
	try {
	    FileInputStream in = new FileInputStream(new File(fileName));
	    p.load(in);
	} catch (Exception e) {
	    defaults();
	    save();
	}
    }
    
    public boolean getBoolean(String key) {
        String tempStr = p.getProperty(key);
	if (tempStr != null && tempStr.equalsIgnoreCase("true")) return true;
	return false;
    }
    
    public void put(String key, String value) {
        p.setProperty(key, value);
    }
    
    
    public void defaults() {
        p.setProperty("playChatSound", "true");
        p.setProperty("playMessageSound", "true");
        p.setProperty("playOnlineSound", "false");
        p.setProperty("playOfflineSound", "false");	
        p.setProperty("newestFirst","true");
        p.setProperty("showOnlyNew","false"); 
	p.setProperty("showOnlyNew","false");
	p.setProperty("away","I am away from my computer.  Please leave a message."); 
	p.setProperty("xa","I am away from my computer.  Please leave a message."); 
	p.setProperty("dnd","I am away from my computer.  Please leave a message."); 
    }
    
    public void save() {
        try {
	    File saveFile = new File(fileName);
	    saveFile.createNewFile();
	    FileOutputStream out = new FileOutputStream(saveFile);
	    p.store(out, "ACommunicator Options - do not modify");
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

}


