package ca.utoronto.atrc.whiteboard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import com.echomine.jabber.*;

public class ACommPrivateChatGUI extends JPanel {

    // as always, the main class
    public ACommunicator aComm;
    public Roster theRoster;
    
    // GUI items
    public JPanel messagePanel;
    public JPanel sendPanel;
    public JPanel buttonPanel;
    public JPanel sendButtonPanel;
    
    public JButton sendButton;
    public JButton refreshButton;
    public JButton showHideWhiteboard;
    public JTextArea composeArea;
    public JList list;
    public DefaultListModel listModel;    
    
    public ACommPrivateChatGUI(ACommunicator aC, Roster r) {
        aComm = aC;
	theRoster = r;
	setLayout(new BorderLayout());
	
        listModel = new DefaultListModel();
	list = new JList(listModel);
        ACommCellRenderer renderer = new ACommCellRenderer();
        list.setCellRenderer(renderer);	
	//list.setPreferredSize(new Dimension(270, 290));
	
	JScrollPane scrollPane = new JScrollPane(list);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	scrollPane.setPreferredSize(new Dimension(290, 340));
	
	composeArea = new JTextArea();//3,25
	composeArea.setLineWrap(true);
        composeArea.setWrapStyleWord(true);
	
	composeArea.addKeyListener(new KeyListener() {
	        public void keyTyped(KeyEvent e) { }
		public void keyReleased(KeyEvent e) { 
	            if (e.getKeyCode() == KeyEvent.VK_ENTER) send();	
		}
		public void keyPressed(KeyEvent e) { }		
	    });
	
	
	JScrollPane composePane = new JScrollPane(composeArea);
	composePane.setPreferredSize(new Dimension(290, 50));

	sendButton = new JButton(aComm.toolKit.sendIcon);
	sendButton.setMnemonic(KeyEvent.VK_S);
	sendButton.setToolTipText("Send Message");
	sendButton.setMargin(new Insets(1,1,1,1));
        sendButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) { send(); }
	    });	
	    
	showHideWhiteboard = new JButton(aComm.toolKit.whiteboardIcon);
	showHideWhiteboard.setMnemonic(KeyEvent.VK_W);
	showHideWhiteboard.setToolTipText("Show or Hide Whiteboard");
	showHideWhiteboard.setMargin(new Insets(1,1,1,1));
        showHideWhiteboard.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    theRoster.showHideWhiteboard();
		}
	    });	

	/*refreshButton = new JButton(aComm.toolKit.refreshIcon);
	refreshButton.setMnemonic(KeyEvent.VK_W);
	refreshButton.setToolTipText("Refresh Messages");
	refreshButton.setMargin(new Insets(1,1,1,1));
        refreshButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    System.out.println("MANUAL REFRESH: NOT YET IMPLEMENTED");
		}
	    });	
	refreshButton.setEnabled(false);*/	    
	    
	    	    
	sendPanel = new JPanel();
	sendPanel.setLayout(new BorderLayout());
	sendPanel.add(composePane, "West");
	sendButtonPanel = new JPanel();
	sendButtonPanel.setLayout(new BorderLayout());
	sendButtonPanel.add(sendButton, "South");
	sendPanel.add(sendButtonPanel, "East");
	messagePanel = new JPanel();
	messagePanel.setLayout(new BorderLayout());
	messagePanel.add(scrollPane, "West");
	buttonPanel = new JPanel();
	buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.Y_AXIS));
	buttonPanel.add(Box.createVerticalGlue());
	//buttonPanel.add(refreshButton);
	buttonPanel.add(showHideWhiteboard);
	messagePanel.add(buttonPanel, "East");

	messagePanel.setBorder(BorderFactory.createTitledBorder("Chat"));
	sendPanel.setBorder(BorderFactory.createTitledBorder("Compose Message"));
	add(messagePanel, "North");
	add(sendPanel, "South");    
    }
    
    
    public void send() {
	String message = composeArea.getText();
	if (message != null && message.length() > 0) {
	    composeArea.setText("");
	    aComm.sendPrivateChatMessage(theRoster.jid, message);
	}    
    }
    
}

