package ca.utoronto.atrc.whiteboard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import com.echomine.jabber.*;

public class ACommRegister {

    // as always, the main class
    public ACommunicator aComm;

    // echomine constructs DISPOSABLE
    public JabberContext context;
    public Jabber jabber;
    public JabberSession session;
    
    public String theServer;
    public int thePort;
    public String theName;
    public String thePass;
    
    // screen 1
    JFrame screen1Frame;
    JPanel screen1Panel;
    JComboBox serverBox;
    JLabel serverLabel;
    JButton nextButton;
    
    // both
    JButton cancelButton;
    
    // screen 2
    JFrame screen2Frame;
    JPanel screen2Panel;
    JLabel nameLabel;
    JTextField nameField;
    JLabel pass1Label;
    JPasswordField pass1Field;
    JLabel pass2Label;
    JPasswordField pass2Field;
    JButton registerButton;
         
   
    RegisterIQMessage rMsg;
    RegisterIQMessage replyRMsg;
    
    public ACommRegister(ACommunicator aC) {
    
        aComm = aC;

        screen1Frame = new JFrame("AComm: New Account Registration (Screen 1 of 2)");
	screen1Frame.addWindowListener(new WindowAdapter() {
           public void windowClosing(WindowEvent e) {
	       aComm.killItAll();
           }});  
	   	   
	   
	registerButton = new JButton("Register Account");
	registerButton.setMnemonic(KeyEvent.VK_R);
	registerButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        String name1 = nameField.getText();
		String p1 = new String(pass1Field.getPassword());
		String p2 = new String(pass2Field.getPassword());
		if (!p1.equals(p2)) {
		    return;
		}
                register(name1, p1);
		screen2Frame.setVisible(false);
		screen2Frame.dispose();
	    }});	   
	   	   
	nextButton = new JButton("Next");
	nextButton.setMnemonic(KeyEvent.VK_N);
	nextButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        String serverStr = (String) serverBox.getSelectedItem();
		theServer = serverStr;
		thePort = 5222;
	        nextScreen(serverStr);
	    }});

	    
	    
	cancelButton = new JButton("Cancel");
	cancelButton.setMnemonic(KeyEvent.VK_C);
	cancelButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        aComm.killItAll();
	    }});	    
	    
	    	
	serverLabel = new JLabel("Server Name:");
	String[] servers = { "illx.org",  "tipic.com", "bloodyxml.com" };
	serverBox = new JComboBox(servers); 
	serverBox.setEditable(true);
	serverLabel.setLabelFor(serverBox);
	serverLabel.setDisplayedMnemonic(KeyEvent.VK_S);
	    		
	
	screen1Panel = new JPanel();
	screen1Panel.setLayout(new GridLayout(2,2));
	
	screen1Panel.add(serverLabel);
	screen1Panel.add(serverBox);
	screen1Panel.add(nextButton);
	screen1Panel.add(cancelButton);
	screen1Panel.setBorder(BorderFactory.createTitledBorder("Select a Jabber Host Server: "));
	screen1Frame.getContentPane().add(screen1Panel);
	screen1Frame.pack();
	screen1Frame.setVisible(true);
    }
    
    public void processMessageEvent(JabberMessageEvent event) {
        JabberMessage msg = event.getMessage();
	int type = msg.getMessageType();
	if (type == 11) {
	    RegisterIQMessage tempRMsg = (RegisterIQMessage) msg;
	    if (tempRMsg.isError()) {
	        JOptionPane.showMessageDialog(null, "Error: "+tempRMsg.getErrorMessage());
		if (rMsg != null) gotRegisterMessage(rMsg);
		else nextScreen(theServer);
	    } else {
	        rMsg = tempRMsg;
	        gotRegisterMessage(rMsg);
	    }
	} else {
	    if (type == 10) {
	        session.disconnect();
	    
		aComm.options.p.setProperty("userName",theName);
		aComm.options.p.setProperty("server", theServer);
		aComm.options.p.setProperty("port", ""+thePort);
		aComm.options.save();
		aComm.doLogin(thePass);	        
	    }
	}
        //System.out.println("Got Message event " + msg.getMessageType() + " " + msg);
    }
    
    public void register(String name, String pass) {
        RegisterIQMessage theMsg = new RegisterIQMessage(RegisterIQMessage.TYPE_SET);
	theMsg.addField("username", name);
	theMsg.addField("password", pass);
	theName = name;
	thePass = pass;
	
	//System.out.println("Sending message: "+theMsg);
	
	try {
	    session.sendMessage(theMsg);
	} catch (Exception e) { e.printStackTrace(); }
    }
    
    public void gotRegisterMessage(RegisterIQMessage theMsg) {
        java.util.HashMap hM = rMsg.getFields();
	//JOptionPane.showMessageDialog(null, "<html><body><p align='center'>"+hM.get("instructions")+"</p></body></html>");

	//JPanel overallPanel = new JPanel();
	//overallPanel.setLayout(new BorderLayout());


        screen2Frame = new JFrame("AComm: New Account Registration (Screen 2 of 2)");
	screen2Frame.addWindowListener(new WindowAdapter() {
           public void windowClosing(WindowEvent e) {
	       aComm.killItAll();
           }});	 	
	
		
	screen2Panel = new JPanel();
	screen2Panel.setLayout(new GridLayout(4,2));
    
    
	nameLabel = new JLabel("Jabber Name: ");
	pass1Label = new JLabel("Password: ");
	pass2Label = new JLabel("Re-type Password: ");
	nameField = new JTextField(20);
	pass1Field = new JPasswordField(20);
	pass2Field = new JPasswordField(20);
	nameLabel.setLabelFor(nameField);
	nameLabel.setDisplayedMnemonic(KeyEvent.VK_N);
	pass1Label.setLabelFor(pass1Field);
	pass1Label.setDisplayedMnemonic(KeyEvent.VK_P);
	pass2Label.setLabelFor(pass2Field);
	pass2Label.setDisplayedMnemonic(KeyEvent.VK_Q);
	
	
	screen2Panel.add(nameLabel);
	screen2Panel.add(nameField);
	screen2Panel.add(pass1Label);
	screen2Panel.add(pass1Field);
	screen2Panel.add(pass2Label);
	screen2Panel.add(pass2Field);
	screen2Panel.add(registerButton);
	screen2Panel.add(cancelButton);

		
	screen2Panel.setBorder(BorderFactory.createTitledBorder("Select a Jabber ID and Password: "));
	screen2Frame.getContentPane().add(screen2Panel);
	screen2Frame.pack();
	screen2Frame.setVisible(true);	
		
    }
    
    public void nextScreen(String serverStr) {	    
	    	
	JabberContext context = new JabberContext("", "", serverStr);
        Jabber jabber = new Jabber();
	
        try {
	    session = jabber.createSession(context);
	    session.connect(serverStr, 5222);
	    RegisterIQMessage theMsg = new RegisterIQMessage();
	    session.sendMessage(theMsg);
	} catch (Exception e) {
	    //e.printStackTrace();
	    return;
	}
	
	session.addMessageListener(new JabberMessageListener() {
	    public void messageReceived(JabberMessageEvent event) {
                processMessageEvent(event);
	    }
	}); 
	
	screen1Frame.setVisible(false);
    }
       
}

