package ca.utoronto.atrc.whiteboard;

import java.awt.Color;
import com.echomine.jabber.*;
import org.jdom.*;
import java.util.List;
import java.util.Iterator;
import java.util.Vector;
import java.io.*;
import org.jdom.input.*;
import org.jdom.output.*;
import javax.swing.*;
import com.incors.plaf.kunststoff.*;

import java.applet.*;
import java.net.URL;
import java.net.MalformedURLException;

public class ACommToolKit {

    public URL icon_url;
    public URL soundURL;
    public String path = "ca/utoronto/atrc/whiteboard/img/";
    public String path2 = "ca/utoronto/atrc/whiteboard/sound/";
    public javax.swing.ImageIcon chatIcon;
    public javax.swing.ImageIcon chatSIcon;
    public javax.swing.ImageIcon normalIcon;
    public javax.swing.ImageIcon normalSIcon; 
    public javax.swing.ImageIcon sendIcon; 
    public javax.swing.ImageIcon listIcon; 
    public javax.swing.ImageIcon whiteboardIcon; 
    public javax.swing.ImageIcon refreshIcon; 
    
    private static AudioClip newChatSound;
    private static AudioClip newMessageSound;
    private static AudioClip onlineSound;
    private static AudioClip offlineSound;
            
    public ACommToolKit() {
    
        try {
	    icon_url = getClass().getClassLoader().getResource(path+ "chat.gif");
	    chatIcon = new javax.swing.ImageIcon(icon_url);
	    icon_url = getClass().getClassLoader().getResource(path+ "chatS.gif");
	    chatSIcon = new javax.swing.ImageIcon(icon_url);
	    icon_url = getClass().getClassLoader().getResource(path+ "normal.gif");
	    normalIcon = new javax.swing.ImageIcon(icon_url);
	    icon_url = getClass().getClassLoader().getResource(path+ "normalS.gif");
	    normalSIcon = new javax.swing.ImageIcon(icon_url); 
	    icon_url = getClass().getClassLoader().getResource(path+ "send.gif");
	    sendIcon = new javax.swing.ImageIcon(icon_url); 
	    icon_url = getClass().getClassLoader().getResource(path+ "list.gif");
	    listIcon = new javax.swing.ImageIcon(icon_url); 
	    icon_url = getClass().getClassLoader().getResource(path+ "whiteboard.gif");
	    whiteboardIcon = new javax.swing.ImageIcon(icon_url); 
	    icon_url = getClass().getClassLoader().getResource(path+ "refresh.gif");
	    refreshIcon = new javax.swing.ImageIcon(icon_url); 
	
	    soundURL = getClass().getClassLoader().getResource(path2+ "boing002.au");
	    newChatSound = Applet.newAudioClip(soundURL);
	    soundURL = getClass().getClassLoader().getResource(path2+ "boing003.au");
	    newMessageSound = Applet.newAudioClip(soundURL);
	    soundURL = getClass().getClassLoader().getResource(path2+ "cbXlight_001.au");
	    onlineSound = Applet.newAudioClip(soundURL);
	    soundURL = getClass().getClassLoader().getResource(path2+ "cbXlight_003.au");
	    offlineSound = Applet.newAudioClip(soundURL);
	    	    
        } catch (Exception e) { e.printStackTrace(); }
    }

    public void playOfflineSound() {
        offlineSound.play();
    }        
        
    public void playOnlineSound() {
        onlineSound.play();
    }    

    public void playNewMessageSound() {   
        newMessageSound.play();
    }        
    
    public void playNewChatSound() {
        newChatSound.play();
    }
    
    public void setUI() {
	KunststoffLookAndFeel kunststoffLnF = new KunststoffLookAndFeel();
        KunststoffLookAndFeel.setCurrentTheme( new KunststoffTheme() );
        try {
	    UIManager.setLookAndFeel(kunststoffLnF);
	} catch (Exception e) { e.printStackTrace(); }
    }
 
    public String elementToString(Element e) {
        String theString = null;
	try {
	    XMLOutputter xmlOut = new XMLOutputter();
	    theString = xmlOut.outputString(e);
	} catch (Exception ex) {
	    //ex.printStackTrace();
	}
	return theString;
    }     
    
    public Element stringToElement(String s) {
        Element e = null;
    	try {
	    StringReader sR = new StringReader(s);
            SAXBuilder sB = new SAXBuilder();
	    Document doc = sB.build(sR);
	    e = doc.detachRootElement();
	} catch (Exception ex) {
	    ex.printStackTrace();
	}
	return e;
    }      
    
    public String jidWithoutEnd(String tJID) {
        JID tempJID;
        try {
	   tempJID = new JID(tJID);
	} catch (Exception e) { 
	    //e.printStackTrace(); 
	    //System.out.println("ERROR in toolKit.jidWithoutEnd"); 
	    return null;
	}
	return tempJID.getJIDWithoutResource();
    }    

    public String jidResource(String tJID) {
        JID tempJID;
        try {
	   tempJID = new JID(tJID);
	} catch (Exception e) { 
	    //e.printStackTrace(); 
	    //System.out.println("ERROR in toolKit.jidWithoutEnd"); 
	    return null;
	}
	return tempJID.getResource();
    }    

    public String jidUsername(String tJID) {
        JID tempJID;
        try {
	   tempJID = new JID(tJID);
	} catch (Exception e) { 
	    //e.printStackTrace(); 
	    //System.out.println("ERROR in toolKit.jidWithoutEnd"); 
	    return null;
	}
	return tempJID.getUsername();
    }     
               
    public String getColourStr(String jid) {
        jid.toLowerCase();
        int sum = jid.length()*jid.length();
	for (int i=0; i<jid.length(); i++) {
	    char ch = jid.charAt(i);
	    Character chC = new Character(ch);
	    sum += chC.getNumericValue(ch) + i;
	}
	sum = sum%30;
	String colour = "000000";
	if (sum == 0) colour = "003366";
	else if (sum == 1) colour = "000099";
	else if (sum == 2) colour = "336600";
	else if (sum == 3) colour = "009900";
	else if (sum == 4) colour = "660066";
	else if (sum == 5) colour = "663300";
	else if (sum == 6) colour = "990000";
	else if (sum == 7) colour = "006666";
	else if (sum == 8) colour = "666600";
	else if (sum == 9) colour = "660033";
	else if (sum == 10) colour = "006633";
	else if (sum == 11) colour = "330066";
	else if (sum == 12) colour = "226622";
	else if (sum == 13) colour = "222266";
	else if (sum == 14) colour = "662222";
	else if (sum == 15) colour = "228800";
	else if (sum == 16) colour = "880022";
	else if (sum == 17) colour = "882200";
	else if (sum == 18) colour = "002288";
	else if (sum == 19) colour = "220088";
	else if (sum == 20) colour = "112288";
	else if (sum == 21) colour = "331177";
	else if (sum == 22) colour = "991100";
	else if (sum == 23) colour = "990011";
	else if (sum == 24) colour = "009911";
	else if (sum == 25) colour = "119900";
	else if (sum == 26) colour = "117711";
	else if (sum == 28) colour = "111177";
	else if (sum == 29) colour = "771111";		
	else colour = "000000";
        return colour;
    }    

    public Color getColour(String jid) {
        return new Color(Integer.parseInt(getColourStr(jid), 16));
    }        

}
