package ca.utoronto.atrc.whiteboard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class ACommWhiteboard extends JPanel {


    public JTextArea infoArea;
    public JButton sendButton;
    public ACommunicator aComm;
    public String jid;

    public ACommWhiteboard(String toJID, ACommunicator aC) {
        aComm = aC;
	jid = toJID;
	
        setSize(300,400);
	setBackground(Color.yellow);
        setLayout(new BorderLayout());
	
	infoArea = new JTextArea(20,5);
	sendButton = new JButton("WB Send");
        sendButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    sendWhiteboardMessage();
		}
	    });
	
	add("North", new JScrollPane(infoArea));
	add("South", sendButton);
    }
    
    public void sendRequestForFullWhiteboard() {
        aComm.sendWhiteboardRequest(jid);
    }
    
    public void sendWhiteboardMessage() {
    
        // The type of the message - "mod" or "full" or "req"
        String type = "mod";
	
	// the vector containing the SVG elements
	Vector svgVector = new Vector();
	svgVector.add("<obj id='123'>foo foo</obj>");
	svgVector.add("<obj id='345'>foo foo</obj>");
	
	// the vector containing the elements to be removed
	Vector svgRMVector = new Vector();
	svgRMVector.add("<obj id='234'>foo foo</obj>");
	
	// the vector containing outstanding descriptions
	Vector descVector = new Vector();
	descVector.add("<desc id='123'>Line 1 (Sara)</desc>");
	descVector.add("<desc id='345'>Line 2 (John)</desc>");
	    
        aComm.sendWhiteboardMessage(jid,type, svgVector, svgRMVector, descVector);
    } 
    
    public void incomingWhiteboardMessage(String sender, String type, Vector svgStrings, Vector svgRMStrings, Vector descObjects) {
        String displayString = "";
	
	displayString = "Whiteboard message from "+sender+"\n\n";
	displayString += "   Type: "+type+"\n";
	if (svgStrings != null) {
	    displayString += "\n   SVG Strings:\n";
	    for (int i=0; i<svgStrings.size(); i++) {
	        displayString += "      "+(String) svgStrings.elementAt(i)+"\n";
	    }
	}
	if (svgRMStrings != null) {
	    displayString += "\n   SVG RM Strings:\n";
	    for (int i=0; i<svgRMStrings.size(); i++) {
	        displayString += "      "+(String) svgRMStrings.elementAt(i)+"\n";
	    }
	}	
	if (descObjects != null) {
	    displayString += "\n   description objects:\n";
	    for (int i=0; i<descObjects.size(); i++) {
	        displayString += "      "+(String) descObjects.elementAt(i)+"\n";
	    }
	} 
	infoArea.setText(displayString);   
    } 

}
